searchNodes=[{"doc":"The Erlang Dead Code Cleaner","ref":"hank.html","title":"hank","type":"module"},{"doc":"Runs a list of rules over a list of files and returns all the dead code pieces it can find.","ref":"hank.html#analyze/5","title":"hank.analyze/5","type":"function"},{"doc":"","ref":"hank.html#get_ast/1","title":"hank.get_ast/1","type":"function"},{"doc":"","ref":"hank.html#t:ms/0","title":"hank.ms/0","type":"type"},{"doc":"","ref":"hank.html#t:parsing_style/0","title":"hank.parsing_style/0","type":"type"},{"doc":"","ref":"hank.html#t:stats/0","title":"hank.stats/0","type":"type"},{"doc":"rebar3 contextual data turned into a type that we can also manually build, if needed","ref":"hank_context.html","title":"hank_context","type":"module"},{"doc":"Return the root folder for an app.","ref":"hank_context.html#app_dir/2","title":"hank_context.app_dir/2","type":"function"},{"doc":"Build a context from a rebar3 state.","ref":"hank_context.html#from_rebar_state/1","title":"hank_context.from_rebar_state/1","type":"function"},{"doc":"Build a context from scratch.","ref":"hank_context.html#new/2","title":"hank_context.new/2","type":"function"},{"doc":"OTP applications included in the project.","ref":"hank_context.html#project_apps/1","title":"hank_context.project_apps/1","type":"function"},{"doc":"","ref":"hank_context.html#t:apps_dirs/0","title":"hank_context.apps_dirs/0","type":"type"},{"doc":"","ref":"hank_context.html#t:t/0","title":"hank_context.t/0","type":"opaque"},{"doc":"Behavior for defining a rule for Hank.","ref":"hank_rule.html","title":"hank_rule","type":"behaviour"},{"doc":"","ref":"hank_rule.html#c:analyze/2","title":"hank_rule.analyze/2","type":"callback"},{"doc":"Analyze the given files with the rule.","ref":"hank_rule.html#analyze/3","title":"hank_rule.analyze/3","type":"function"},{"doc":"The list of default rules to apply","ref":"hank_rule.html#default_rules/0","title":"hank_rule.default_rules/0","type":"function"},{"doc":"","ref":"hank_rule.html#c:ignored/2","title":"hank_rule.ignored/2","type":"callback"},{"doc":"Check if given rule should be ignored from results","ref":"hank_rule.html#is_ignored/3","title":"hank_rule.is_ignored/3","type":"function"},{"doc":"","ref":"hank_rule.html#t:asts/0","title":"hank_rule.asts/0","type":"type"},{"doc":"","ref":"hank_rule.html#t:ignore_pattern/0","title":"hank_rule.ignore_pattern/0","type":"type"},{"doc":"","ref":"hank_rule.html#t:ignore_spec/0","title":"hank_rule.ignore_spec/0","type":"type"},{"doc":"","ref":"hank_rule.html#t:result/0","title":"hank_rule.result/0","type":"type"},{"doc":"","ref":"hank_rule.html#t:t/0","title":"hank_rule.t/0","type":"type"},{"doc":"Utility functions","ref":"hank_utils.html","title":"hank_utils","type":"module"},{"doc":"Returns a MFA tuple for given application node","ref":"hank_utils.html#application_node_to_mfa/1","title":"hank_utils.application_node_to_mfa/1","type":"function"},{"doc":"Same as attr_args/3 but calling erl_syntax:concrete/1 for each element","ref":"hank_utils.html#attr_args_concrete/2","title":"hank_utils.attr_args_concrete/2","type":"function"},{"doc":"Macro dodging version of erl_syntax:attribute_name/1","ref":"hank_utils.html#attr_name/1","title":"hank_utils.attr_name/1","type":"function"},{"doc":"Format rule result text for console output","ref":"hank_utils.html#format_text/2","title":"hank_utils.format_text/2","type":"function"},{"doc":"Get the function definition name and arity of a given Function Node.","ref":"hank_utils.html#function_description/1","title":"hank_utils.function_description/1","type":"function"},{"doc":"Get the function name of a given Function Node.","ref":"hank_utils.html#function_name/1","title":"hank_utils.function_name/1","type":"function"},{"doc":"Get the function definition tuple {name, arity} of a given Function Node.","ref":"hank_utils.html#function_tuple/1","title":"hank_utils.function_tuple/1","type":"function"},{"doc":"Before OTP 23.2 test suites implemented an _implicit_ behavior. The only way to figure out that a module was actually a test suite was by its name.","ref":"hank_utils.html#is_old_test_suite/1","title":"hank_utils.is_old_test_suite/1","type":"function"},{"doc":"Get the macro arity of given Node","ref":"hank_utils.html#macro_arity/1","title":"hank_utils.macro_arity/1","type":"function"},{"doc":"Get the macro definition name and arity of a given Macro Node.","ref":"hank_utils.html#macro_definition_name/1","title":"hank_utils.macro_definition_name/1","type":"function"},{"doc":"Generates a macro from the variable that's used in a control flow attribute. e.g. returns ?MACRO if it receives -ifdef(MACRO).","ref":"hank_utils.html#macro_from_control_flow_attr/1","title":"hank_utils.macro_from_control_flow_attr/1","type":"function"},{"doc":"Get the parsed macro name of given Node","ref":"hank_utils.html#macro_name/1","title":"hank_utils.macro_name/1","type":"function"},{"doc":"Returns true if the node contains the atom. Only analyzes functions and attributes.","ref":"hank_utils.html#node_has_atom/2","title":"hank_utils.node_has_atom/2","type":"function"},{"doc":"Whether the given Node node has defined the given AttrNames attribute names or not","ref":"hank_utils.html#node_has_attrs/2","title":"hank_utils.node_has_attrs/2","type":"function"},{"doc":"Returns the line number of the given node","ref":"hank_utils.html#node_line/1","title":"hank_utils.node_line/1","type":"function"},{"doc":"Whether one of the given paths is contained inside the other one or not. It doesn't matter which one is contained at which other. Verifies if FilePath and IncludePath refer both to the same file. Note that we can't just compare both filename:absname's here, since we don't really know what is the absolute path of the file referred by the include directive.","ref":"hank_utils.html#paths_match/2","title":"hank_utils.paths_match/2","type":"function"},{"doc":"Main entry point for the rebar3 hank plugin","ref":"rebar3_hank.html","title":"rebar3_hank","type":"module"},{"doc":"Plugin provider for rebar3 hank","ref":"rebar3_hank_prv.html","title":"rebar3_hank_prv","type":"module"},{"doc":"A rule to detect hrl attributes used in just one module: Attributes supported: -define -record It will suggest to place those attributes inside the module to avoid having (and including) a hrl file. Note This rule assumes that hrl files will not be used outside your project. If you are writing a library that requires your clients to use some of your header files and attributes, you can add an ignore rule in rebar.config for it.","ref":"single_use_hrl_attrs.html","title":"single_use_hrl_attrs","type":"module"},{"doc":"This builds a list of header files with its attributes. Then traverse the file ASTs mapping their macros and records And checks whether they were used just once.","ref":"single_use_hrl_attrs.html#analyze/2","title":"single_use_hrl_attrs.analyze/2","type":"function"},{"doc":"Rule ignore specifications. Example: - hank ( [ { single_use_hrl_attrs , [ &quot;ALL&quot; , %% Will ignore ?ALL, ?ALL() and ?ALL(X) { &quot;ZERO&quot; , 0 } , %% Will ignore ?ZERO() but not ?ZERO(X) nor ?ZERO { &quot;ONE&quot; , 1 } , %% Will ignore ?ONE(X) but not ?ONE() nor ?ONE { &quot;NONE&quot; , none } , %% Will ignore ?NONE but not ?NONE(X) nor ?NONE() record_name %% Will ignore #record_name ] } ,","ref":"single_use_hrl_attrs.html#ignored/2","title":"single_use_hrl_attrs.ignored/2","type":"function"},{"doc":"A rule to detect header files used in just one module. To avoid this warning, include the content of the header file into the module. Note This rule assumes that hrl files will not be used outside your project. If you are writing a library that requires your clients to use some of your header files, you can add an ignore rule in rebar.config for it.","ref":"single_use_hrls.html","title":"single_use_hrls","type":"module"},{"doc":"It doesn't make sense to provide individual ignore spec support here. The rule's basic unit is already a file.","ref":"single_use_hrls.html#ignored/2","title":"single_use_hrls.ignored/2","type":"function"},{"doc":"A rule to detect unnecessary function arguments. The rule emits a warning for each function argument that is consistently ignored in all function clauses. To avoid this warning, remove the unused argument(s). Note This rule will not emit a warning if the function implements a NIF call (assuming that the stub function calls erlang:nif_error/1,2 ) or if it's a behaviour callback. In particular, the rule will not emit a warning for any exported function in modules that implement non-OTP behaviors or OTP behaviors that have dynamic callbacks, like gen_statem or ct_suite . It will also not emit a warning if the function is &quot;known&quot; even if not in a behaviour, like parse_transform/2.","ref":"unnecessary_function_arguments.html","title":"unnecessary_function_arguments","type":"module"},{"doc":"Rule ignore specifications. Example: - hank ( [ { unnecessary_function_arguments , %% You can give a list of multiple specs or a single one [ %% Will ignore any unused argument from ignore_me/2 within the module { ignore_me , 2 } , %% Will ignore the 2nd argument from ignore_me_too/3 within the module { ignore_me_too , 3 , 2 } , %% Will ignore any unused argument from any ignore_me_again/x %% within the module (no matter the function arity) ignore_me_again ] } ] ) .","ref":"unnecessary_function_arguments.html#ignored/2","title":"unnecessary_function_arguments.ignored/2","type":"function"},{"doc":"","ref":"unnecessary_function_arguments.html#t:imp_callbacks/0","title":"unnecessary_function_arguments.imp_callbacks/0","type":"type"},{"doc":"A rule to detect unused callbacks. This rule will check all callbacks defined in a module and find those that are not used anywhere in the module itself. It will emit a warning if it can't find the callback's atom name being used anywhere within a module. It will NOT emit a warning if an atom named as a callback is being used, no matter for what that atom is used. This limitation is due to the fact that there are many ways to call a function in Erlang (particularly when dynamic calls are involved). The assumption is that if you define a callback for a behavior, your generic module (where the callback is defined) should call that function at some point, using the implementation provided by the specific module (the one that implements the behavior). To avoid this warning, remove the unused callback definition. Note For this rule to apply, it's assumed that callbacks defined for a particular behavior are only used within the same module that defines it. If you define behaviors in your project and you use their callbacks from other modules, you can add an ignore rule in rebar.config for it.","ref":"unused_callbacks.html","title":"unused_callbacks","type":"module"},{"doc":"Rule ignore specifications. Example: - hank ( [ { unused_callbacks , [ all , %% Will ignore all versions of the all callback (i.e. any arity) { just , 1 } %% Will ignore just(term()) but not just() nor just(_, _) callbacks ] } ,","ref":"unused_callbacks.html#ignored/2","title":"unused_callbacks.ignored/2","type":"function"},{"doc":"A rule to detect unused configuration options It will find options that are no longer used around the code: - All the options from the *.config files (excepting rebar.config, elvis.config and relx.config) - The env list inside any *.app.src files To avoid this warning, remove the unused parameters. Note For this rule to apply, it's assumed that configuration options for an Erlang application are only consumed within said Erlang application or the other applications in the same umbrella project. If you have a dependency that consumes an environment parameter from one of your project applications, you can add an ignore rule in rebar.config for it.","ref":"unused_configuration_options.html","title":"unused_configuration_options","type":"module"},{"doc":"Detects unused config options. It gets the options from .config and .app.src files and then: Builds an index with file/options. Gets the atoms used around the .erl and .hrl files. Calculates the unused atoms (options) and return the results.","ref":"unused_configuration_options.html#analyze/2","title":"unused_configuration_options.analyze/2","type":"function"},{"doc":"Rule ignore specifications. Only valid in rebar.config since attributes are not allowed in config files. Example: { hank , [ { ignore , [ { &quot;this_file.config&quot; , unused_configuration_options , [ ignore_option ] } ] } ] } .","ref":"unused_configuration_options.html#ignored/2","title":"unused_configuration_options.ignored/2","type":"function"},{"doc":"A rule to detect unused header files. To avoid this warning, remove the unused header files. Note This rule assumes that hrl files will not be used outside your project. If you are writing a library that requires your clients to use some of your header files, you can add an ignore rule in rebar.config for it.","ref":"unused_hrls.html","title":"unused_hrls","type":"module"},{"doc":"It doesn't make sense to provide individual ignore spec support here. The rule's basic unit is already a file.","ref":"unused_hrls.html#ignored/2","title":"unused_hrls.ignored/2","type":"function"},{"doc":"A rule to detect unused macros. To avoid this warning, remove the unused macros. Note that for header files, this rule will fail to detect some unused macros. Particularly, in the case where you have an unused macro defined in a header file and another macro with the same name and arity defined somewhere else that is used. Since determining precisely what files are included in each -include attribute is not trivial, Hank will act conservatively and not make any effort to verify where each macro that's used is defined. So, if you have a project with multiple definitions of the same macro with the same arity... well... as long as one of them is used, none of them will be reported as unused. Note This rule assumes that hrl files will not be used outside your project. If you are writing a library that requires your clients to use a macro defined in some of your header files, you can add an ignore rule in rebar.config for it.","ref":"unused_macros.html","title":"unused_macros","type":"module"},{"doc":"Rule ignore specifications. Example: - hank ( [ { unused_macros , [ &quot;ALL&quot; , %% Will ignore ?ALL, ?ALL() and ?ALL(X) { &quot;ZERO&quot; , 0 } , %% Will ignore ?ZERO() but not ?ZERO(X) nor ?ZERO { &quot;ONE&quot; , 1 } , %% Will ignore ?ONE(X) but not ?ONE() nor ?ONE { &quot;NONE&quot; , none } %% Will ignore ?NONE but not ?NONE(X) nor ?NONE() ] } ,","ref":"unused_macros.html#ignored/2","title":"unused_macros.ignored/2","type":"function"},{"doc":"A rule to detect unused record fields. The rule will detect fields that are defined as part of a record but never actually used anywhere. To avoid this warning, remove the unused record fields. Note that for header files, this rule will fail to detect some unused fields. Particularly, in the case where you have an unused field defined in a header file and another record with the same name and the same field defined somewhere else that is used. Since determining precisely what files are included in each -include attribute is not trivial, Hank will act conservatively and not make any effort to verify where each record field that's used is defined. So, if you have a project with multiple definitions of the same record with the same field... well... as long as one of them is used, none of them will be reported as unused. Note This rule assumes that your code will never use the underlying tuple structure of your records directly. If you do so, you can add an ignore rule in rebar.config for it.","ref":"unused_record_fields.html","title":"unused_record_fields","type":"module"},{"doc":"Rule ignore specifications. Example: - hank ( [ { unused_record_fields , [ a_record , %% Will ignore all fields in #a_record { a_record , a_field } %% Will ignore #a_record.a_field ] } ] ) .","ref":"unused_record_fields.html#ignored/2","title":"unused_record_fields.ignored/2","type":"function"},{"doc":"The Erlang Dead Code Cleaner Mr. Scorpio says productivity is up 2%, and it's all because of my motivational techniques, like donuts and the possibility of more donuts to come. (Homer Simpson)","ref":"readme.html","title":"rebar3_hank","type":"extras"},{"doc":"If Hank detects issues in your code, it will report them as follows… src / lapp . erl : 18 : maybe_evaluate / 3 doesn &#39;t need its #2 argument src/lapp.erl:15: maybe_evaluate/2 doesn&#39; t need its # 1 argument src / lapp . erl : 5 : ? DEFAULT_SAMPLE_RATE is unused src / lapp . app . src : 0 : sample_rate is not used anywhere in the code src / include / header . hrl : 2 : ? SOME_MACRO / 1 is used only at src / lapp . erl src / my_behaviour . erl : 3 : Callback process / 1 is not used anywhere in the module src / include / header . hrl : 1 : ? APP_HEADER is unused src / main . erl : 8 : Field color in record state is unused","ref":"readme.html#sample-output","title":"rebar3_hank - Sample Output","type":"extras"},{"doc":"$ rebar3 compile","ref":"readme.html#build","title":"rebar3_hank - Build","type":"extras"},{"doc":"$ rebar3 test","ref":"readme.html#test","title":"rebar3_hank - Test","type":"extras"},{"doc":"Add the plugin to your rebar config: { project_plugins , [ rebar3_hank ] } Then just call the plugin directly in an existing application: $ rebar3 hank # or… $ rebar3 kiwf # (Kill It With Fire) This will review your project, analyzing every *.[he]rl file in it (optionally skipping some folders/files if you want to - see below). Note that Hank will not consider files from your project dependencies for the analysis. It will only check the source code in your current application ( applications , if you're working in an umbrella project). It will then apply its rules and produce a list of all the dead code ( specially oxbow code ) that you can effectively delete and/or refactor. Command-Line Options $ rebar3 help hank Usage: rebar3 hank [-u &lt;unused_ignores&gt;] -u, --unused_ignores Warn on unused ignores (default: true). By default, Hank will emit warnings such as the following ones if you are ignoring rules that you don't need to ignore (more on that below). But you can turn those warnings off, by using --unused_ignores=no . It's worth noting that, even when those warnings are printed, that doesn't affect the overall result of the command. That is, if Hank can't find any instances of oxbow code, it will return successfully (i.e. exit code: 0 ) even when it may print these warnings. ===&gt; The following ignore specs are no longer needed and can be removed: * src/ignore_not_empty.erl: unused_hrls * src/ignore_not_empty.erl: unused_configuration_options","ref":"readme.html#usage","title":"rebar3_hank - Usage","type":"extras"},{"doc":"In principle, Hank should have Dialyzer levels of certainty. That is: if Hank points at some code, you can be 100% sure it's dead . That means that if you find some false positives (i.e. Hank pointed at some code that was not really dead / should not be deleted), please report it as a bug and we'll take care of fixing it.","ref":"readme.html#certainty","title":"rebar3_hank - Certainty","type":"extras"},{"doc":"The plugin supports the following configuration options in the hank section of rebar.config : rules ( [hank_rule:t()] ): This is the list of rules to apply to the analyzed code. Each rule is a module that should apply the hank_rule behavior. If this option is not defined, Hank will apply all the default rules . parsing_style ( hank:parsing_style() ): This parameter determines if Hank should parse files in a parallel ( rpc:pmap/3 ) or sequential ( lists:map/2 ) fashion. The default value is parallel since it's faster. It's recommended to use sequential when reporting bugs since the error descriptions are usually more detailed. ignore ( [file:filename_all() | {file:filename_all(), hank_rule:t() | [hank_rule:t()]} | {file:filename_all(), hank_rule:t() | [hank_rule:t()], list()}] ): List of wildcard patterns representing the files and rules that Hank will ignore when formatting. Tuple format is used to ignore either a specific rule or a set of rules in those files. % single rule { hank , [ { ignore , [ &quot;rel/**/*&quot; , &quot;lib/some_module.erl&quot; , { &quot;test/**/*.erl&quot; , unnecessary_function_arguments } ] } ] } or % set of rules (after expansion, the same wildcard and options are used for all rules) { hank , [ { ignore , [ { &quot;test/**/*.erl&quot; , [ unused_macros , unnecessary_function_arguments ] } ] } ] } For ignoring options for unused_configuration_options rule, set a list of keys from the .config files you want to ignore. { hank , [ { ignore , [ { &quot;sys.config&quot; , unused_configuration_options , [ not_used_but_ignored ] } ] } ] } You can also ignore a specific file adding the attribute -hank ignore. to it. And you can ignore specific rules adding the attribute -hank [hank_rule:t()]. with the list of rules you want to ignore. Ignore specific rule items You can even ignore specific rule items with the -hank attribute by giving extra ignore specifications for each rule, example: - hank ( [ single_use_hrls , %% Will ignore the whole rule within the module { unused_macros , [ &quot;ALL&quot; , %% Will ignore ?ALL, ?ALL() and ?ALL(X) { &quot;ZERO&quot; , 0 } , %% Will ignore ?ZERO() but not ?ZERO(X) nor ?ZERO { &quot;ONE&quot; , 1 } , %% Will ignore ?ONE(X) but not ?ONE() nor ?ONE { &quot;NONE&quot; , none } %% Will ignore ?NONE but not ?NONE(X) nor ?NONE() ] } , { unused_record_fields , [ a_record , %% Will ignore all fields in #a_record { a_record , a_field } %% Will ignore #a_record.a_field ] } , { unused_callbacks , [ all , %% Will ignore all versions of the all callback (i.e. any arity) { just , 1 } %% Will ignore just(term()) but not just() nor just(_, _) callbacks ] } , { unused_configuration_options , [ option , %% Will ignore any appearance of option { &quot;this_file.config&quot; , option } %% Will ignore option if it appears in &quot;this_file.config&quot; ] } , { single_use_hrl_attrs , [ &quot;ALL&quot; , %% Will ignore ?ALL, ?ALL() and ?ALL(X) { &quot;ZERO&quot; , 0 } , %% Will ignore ?ZERO() but not ?ZERO(X) nor ?ZERO { &quot;ONE&quot; , 1 } , %% Will ignore ?ONE(X) but not ?ONE() nor ?ONE { &quot;NONE&quot; , none } , %% Will ignore ?NONE but not ?NONE(X) nor ?NONE() record_name %% Will ignore #record_name ] } , { unnecessary_function_arguments , [ { ignore_me , 2 } , %% Will ignore any unused argument from ignore_me/2 { ignore_me_too , 3 , 2 } , %% Will ignore the 2nd argument from ignore_me_too/3 ignore_me_again ] } ] ) . %% Will ignore any unused argument from any `ignore_me_again/x` within the module (no matter the arity) Refer to each rule documentation for further details.","ref":"readme.html#configuration","title":"rebar3_hank - Configuration","type":"extras"},{"doc":"Find detailed information about the rules provided by Hank in hex docs .","ref":"readme.html#rules","title":"rebar3_hank - Rules","type":"extras"},{"doc":"@elbrujohalcon presented Hank in a lightning talk at CodeBEAM V SF 2021. Watch his talk where he shows an example of using Hank in an iterative process:","ref":"readme.html#full-example","title":"rebar3_hank - Full Example","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2020 NextRoll Inc., Brujo Benavides, Pablo Brudnick, and Diego Calero Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]